﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Problems.Instances.Types
{
    /// <summary>
    /// Describes instances of the Linear Ordering Problem (LOP).
    /// </summary>
    public class LOPData
    {
        /// <summary>
        /// The name of the instance
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Optional! The description of the instance
        /// </summary>
        public string Description { get; set; }

        /// <summary>
        /// The size of the Matrix
        /// </summary>
        public int Dimension { get; set; }

        /// <summary>
        /// An NxN Matrix
        /// </summary>
        public double[,] Matrix { get; set; }

        /// <summary>
        /// Optional! The best known Permutation
        /// </summary>
        public int[] BestKnownPermutation { get; set; }

        /// <summary>
        /// Optional! The quality value of the <see cref="BestKnownPermutation"/>
        /// </summary>
        public double? BestKnownQuality { get; set; }
    }
}
